﻿
-- My Garrison is Done --
-- Written by Jaxom of Hellfire --
-- Based on an Idea by Cederra of Hellfire, He helps test my addons and this was his idea. --
-- GNU General Public License version 3 (GPLv3) --

GarrisonDone_Version = GetAddOnMetadata("GarrisonDone", "Version")

    -- DEFAULTS --

local playerName = UnitName("player");
local character = UnitName("player").."-"..GetRealmName();
local faction = UnitFactionGroup("player")
local self = GarrisonDone;
local toon = character:match("([^-]+)")
local DCF = DEFAULT_CHAT_FRAME;



    -- ON LOAD --

function GarrisonDone_OnLoad()

    
    -- START --
        -- Assign Tabs for second Tab to show alts --
        PanelTemplates_SetNumTabs(GarrisonDoneFrame, 3);  -- 3 = frames total. --
        PanelTemplates_SetTab(GarrisonDoneFrame, 1);      -- 1 = tab 1 selected. --
        GarrisonDoneEditFrame:Show();
        GarrisonDoneAltEditFrame:Hide();
        GarrisonDoneOptEditFrame:Hide();
        
        
    -- LOCK FRAME SIZE SETTINGS --
        
        GarrisonDoneFrame:SetMinResize(195,245);
        GarrisonDoneFrame:SetMaxResize(195,245);
        
	    table.insert(UISpecialFrames,"GarrisonDoneFrame");     
        
    -- SLASH COMMANDS --
        
        SlashCmdList["GARRISONDONE"] = function(sMsg)
			GarrisonDone_Slash_Command(sMsg)
		end
		SLASH_GARRISONDONE1 = "/mgd";
        SLASH_GARRISONDONE2 = "/gdone";
        
        GarrisonDone_Loaded();
end
 
    
    
    -- Set Default Variables --
function GarrisonDone_Loaded(self)
    if GarrisonDone_Varsc == nil then
        GarrisonDone_Varsc = GarrisonDone_defaults
        end
    if GarrisonDone_Varsc.version < GarrisonDone_Version then
        GarrisonDone_Varsc_temp = GarrisonDone_defaults;
        for k,v in GarrisonDone_Varsc do
    if (GarrisonDone_defaults["Vars"][k]) then
        GarrisonDone_Varsc_temp[k] = v;
        end
    end
        GarrisonDone_Varsc_temp["version"] = GarrisonDone_Version;
        GarrisonDone_Varsc = GarrisonDone_Varsc_temp;
    end
    
    -- REGISTER EVENTS --
    -- Main frame --
for k, v in pairs({
	"VARIABLES_LOADED",
	"REGISTERFORDRAG",
	"STORETEXT",
	"ONTEXTCHANGED",
	"UPDATE",
	"GETTEXT",
	"SETTEXT",
	"ONSHOW",
	"ONHIDE",
	"ONCLICK",
	"ZONE_CHANGED",
	"ZONE_CHANGED_INDOORS",
	"ZONE_CHANGED_NEW_AREA",
	"GARRISON_UPDATE",
	"CHAT_MSG_SYSTEM",
	"PLAYER_ENTERING_WORLD",
    "UNIT_SPELLCAST_START",
    "UNIT_SPELLCAST_STOP",
	"UNIT_SPELLCAST_SUCCEEDED",
	"LOOT_CLOSED",
	"ADDON_LOADED",
	"PLAYER_LOGIN",
    "PLAYER_LOGOUT",
	"GARRISON_FOLLOWER_ADDED",
	"GARRISON_FOLLOWER_LIST_UPDATE",
	"GARRISON_FOLLOWER_REMOVED",
	"GARRISON_HIDE_LANDING_PAGE",
	"GARRISON_SHOW_LANDING_PAGE",
	"GARRISON_USE_PARTY_GARRISON_CHANGED",
    "TAXIMAP_OPENED",
    }) 
    
    do GarrisonDoneFrame:RegisterEvent(v) 
    end
end
   
    -- Function - Load Variables and fire it up :) --

-- EVENT FUNCTIONS --

function GarrisonDone_OnEvent(self, event, ...)
        if event == "VARIABLES_LOADED" then
            
        GarrisonDone_Varsc.version = GarrisonDone_Varsc.version;
		if GarrisonDone_Varsc.version == "nil" then
			GarrisonDone_Varsc.version = ""
		end
            -- Last Login to creat timer for reset --
        GarrisonDone_Varsc.lastLogin = GarrisonDone_Varsc.lastLogin;
		if GarrisonDone_Varsc.lastLogin == "nil" then
        GarrisonDone_Varsc.lastLogin = ""
        end
            -- Last Logout to creat timer for reset --
        GarrisonDone_Varsc.lastLogout = GarrisonDone_Varsc.lastLogout;
		if GarrisonDone_Varsc.lastLogout == "nil" then
        GarrisonDone_Varsc.lastLogout = ""
        end
            -- How many Nodes left to Mine --
        GarrisonDone_Varsc.miningLeft = tonumber(GarrisonDone_Varsc.miningLeft);
		if GarrisonDone_Varsc.miningLeft == "nil" then
			GarrisonDone_Varsc.miningLeft = ""
		end
            -- Max Mining based on Mine LvL --
        GarrisonDone_Varsc.maxMining = tonumber(GarrisonDone_Varsc.maxMining);
		if GarrisonDone_Varsc.maxMining == "nil" then
			GarrisonDone_Varsc.maxMining = ""
		end
            -- How many herbs still to pick --
        GarrisonDone_Varsc.herbingLeft = tonumber(GarrisonDone_Varsc.herbingLeft);
		if GarrisonDone_Varsc.herbingLeft == "nil" then
			GarrisonDone_Varsc.herbingLeft = ""
		end
            -- Max Herbing based on garden LvL --
        GarrisonDone_Varsc.maxHerbing = tonumber(GarrisonDone_Varsc.maxHerbing);
		if GarrisonDone_Varsc.maxHerbing == "nil" then
			GarrisonDone_Varsc.maxHerbing = ""
		end        
		    -- Here in case i need a refrence table --
		GarrisonDone_Varsc.reference = GarrisonDone_Varsc.reference;
		if GarrisonDone_Varsc.refrence == "nil" then
			GarrisonDone_Varsc.reference = ""
		end
            -- Do you have a Garrison --
        GarrisonDone_Varsc.hasGarrison = GarrisonDone_Varsc.hasGarrison;
		if GarrisonDone_Varsc.hasGarrison == "nil" then
			GarrisonDone_Varsc.hasGarrison = ""
		end
            -- Do you have Mine nodes --
        GarrisonDone_Varsc.nodes = GarrisonDone_Varsc.nodes;
		if GarrisonDone_Varsc.nodes == "nil" then
			GarrisonDone_Varsc.nodes = ""
		end
            -- Hide /Show Variable for Auto Show --
        GarrisonDone_Varsc.auto = GarrisonDone_Varsc.auto;
		if GarrisonDone_Varsc.auto == "nil" then
		GarrisonDone_Varsc.auto = not(GarrisonDone_Varsc.auto)
        end
            -- Hide /Show Variable for Floating Button --        
        GarrisonDone_Varsc.button = GarrisonDone_Varsc.button; 
		if GarrisonDone_Varsc.button == "nil" then
		GarrisonDone_Varsc.button = not(GarrisonDone_Varsc.button)
        end 
            -- ON /OFF Variable for Audible Warning --        
        GarrisonDone_Varsc.warning = GarrisonDone_Varsc.warning; 
		if GarrisonDone_Varsc.warning == "nil" then
	    GarrisonDone_Varsc.warning = not(GarrisonDone_Varsc.warning)
		end
            -- ON /OFF Variable for Manual Frame Control --        
        GarrisonDone_Varsc.manual = GarrisonDone_Varsc.manual; 
		if GarrisonDone_Varsc.manual == "nil" then
	    GarrisonDone_Varsc.manual = not(GarrisonDone_Varsc.manual)
		end
    end
        GarrisonDone_CompLogin(toon, when);
end	

    
        -- Check if player is lvl 90 --
function GarrisonDone_HasGarrison(self, event, ...)
        local level = UnitLevel("player")
        if event == "ADDON_LOADED" then
	    if level >= 90 and (IsQuestFlaggedCompleted(34586) or IsQuestFlaggedCompleted(34378)) then
		    GarrisonDone_Varsc.hasGarrison = true
        end
        elseif level < 90 then GarrisonDone_Varsc.hasGarrison = false
        GarrisonDone_ShutDown(self, ShutDown);
    end
end
  
        -- Not Level 90 or has not Unlocked Garrison --
function GarrisonDone_ShutDown(self, ShutDown)
        if GarrisonDone_Varsc.hasGarrison == false then        
        for k, v in pairs({
	        "VARIABLES_LOADED",
	        "REGISTERFORDRAG",
	        "STORETEXT",
	        "ONTEXTCHANGED",
	        "UPDATE",
	        "GETTEXT",
	        "SETTEXT",
	        "ONSHOW",
	        "ONHIDE",
	        "ONCLICK",
	        "ZONE_CHANGED",
	        "ZONE_CHANGED_INDOORS",
	        "ZONE_CHANGED_NEW_AREA",
	        "GARRISON_UPDATE",
	        "CHAT_MSG_SYSTEM",
	        "PLAYER_ENTERING_WORLD",
            "PLAYER_ALIVE",
            "UNIT_SPELLCAST_START",
            "UNIT_SPELLCAST_STOP",
	        "UNIT_SPELLCAST_SUCCEEDED",
	        "LOOT_CLOSED",
	        "ADDON_LOADED",
	        "PLAYER_LOGIN",
            "PLAYER_LOGOUT",
	        "GARRISON_FOLLOWER_ADDED",
	        "GARRISON_FOLLOWER_LIST_UPDATE",
	        "GARRISON_FOLLOWER_REMOVED",
	        "GARRISON_HIDE_LANDING_PAGE",
	        "GARRISON_SHOW_LANDING_PAGE",
	        "GARRISON_USE_PARTY_GARRISON_CHANGED",
            "TAXIMAP_OPENED",
        }) 
    
    do GarrisonDoneFrame:UnregisterEvent(v) 
    end
        MGD_Button:Hide();
        GarrisonDoneFrame:Hide();
        DisableAddOn("GarrisonDone");
        DEFAULT_CHAT_FRAME:AddMessage("|cffff0000You do not have A Garrison, |cfffeef02Disabling Addon")
        else
        return
    end    
end

  
        -- Is Player in there Garrison, if yes auto Open --
function GarrisonDone_FrameAuto(self, event, ...)
        local playerName = UnitName("player");
        local mapID = GetCurrentMapAreaID();
        local mapname = GetMapNameByID(mapID);
        local zoneName = GetSubZoneText();
        local zoneText = GetMinimapZoneText();
        
        if event == "ZONE_CHANGED" then
            
                -- Alliance --
			if (zoneText == (""..playerName.."'s Garrison") and GarrisonDone_Varsc.auto == true) or zoneText == "Town Hall" then
			GarrisonDoneFrame:Show();
            PanelTemplates_SetTab(GarrisonDoneFrame, 1);
            GarrisonDoneEditFrame:Show();
            GarrisonDoneAltEditFrame:Hide();
            GarrisonDoneOptEditFrame:Hide();
            elseif (mapname ~= "Lunarfall" and GarrisonDone_Varsc.manual == false) then
			GarrisonDoneFrame:Hide();
            
                -- Horde --
			elseif (zoneText == (""..playerName.."'s Fort") and GarrisonDone_Varsc.auto == true) or zoneText == "Town Hall" then
			GarrisonDoneFrame:Show();
            PanelTemplates_SetTab(GarrisonDoneFrame, 1);
            GarrisonDoneEditFrame:Show();
            GarrisonDoneAltEditFrame:Hide();
            GarrisonDoneOptEditFrame:Hide();
            elseif (mapname ~= "Frostwall" and GarrisonDone_Varsc.manual == false) then
			GarrisonDoneFrame:Hide();
        end
    end
end
 
            -- No Misions in Progress Game Menu Warning --
local function hook_GameMenuFrame_OnShow(self)
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
        if mip == 0 then
            GarrisonDoneFrame:Show();
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
        PlaySound("RaidWarning", "Master")
    end
end
    hooksecurefunc("GameMenuFrame_OnShow", hook_GameMenuFrame_OnShow)


            -- No Misions in Progress Flight Path Warning --
function GarrisonDone_WarningFp(self, event, ...)
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
    if event == "TAXIMAP_OPENED" then
        if mip == 0 then
            GarrisonDoneFrame:Show();
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            PlaySound("RaidWarning", "Master")
        end
    end
end
              -- No Misions in Progress Zone Change Warning --        
function GarrisonDone_WarningZc(self, event, ...)     
    if event == "ZONE_CHANGED" then
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
        local mapID = GetCurrentMapAreaID();
        local mapname = GetMapNameByID(mapID);
        local zone = GetCurrentMapZone();
        local zoneName = GetSubZoneText();
        local zoneText = GetMinimapZoneText();
        local faction = UnitFactionGroup("player")
          
                -- Alliance --
        if faction == "Alliance" then
	    if (zoneName == (""..playerName.."'s Garrison") or zoneText == (""..playerName.."'s Garrison")) then
            if mip == 0 then
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
                end           
            end
        end
               -- Horde --
        elseif faction == "Horde" then
	    if (zoneName == (""..playerName.."'s Fort") or zoneText == (""..playerName.."'s Fort"))  then
        if mip == 0 then
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
    --            end
            end
        end
    end
        elseif mip ~= 0 then 
            return
        end
    end
end
        
        
        -- No Misions in Progress Draenor Zone Warning --
function GarrisonDone_WarnZone(self, event, ...)
        if event == "ZONE_CHANGED_NEW_AREA" then
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
        local mapID = GetCurrentMapAreaID();
        local mapname = GetMapNameByID(mapID);
        local zone = GetCurrentMapZone();
        local faction = UnitFactionGroup("player")
        
        if mip == 0 then
        if faction == "Alliance" then    
        if mapID == 947 then -- Shadowmoon Valley
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Garrison")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end        
        elseif mapID == 941 then -- Frostfire Ridge
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Highpass")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 949 then -- Gorgrond
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Highpass")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 946 then -- Talador
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Fort Wrynn")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 948 then -- Spires of Arak
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Southport")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 950 then -- Nagrand
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Telaari Station")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 978 then -- Ashran
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Garrison")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 945 then -- Tanaan Jungle
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933UnKnown")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        end
        
                                                    -- Find HORDE OUTPOSTS --
        elseif faction == "Horde" then
        if mapID == 947 then -- Shadowmoon Valley
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 941 then -- Frostfire Ridge
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 949 then -- Gorgrond
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 946 then -- Talador
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 948 then -- Spires of Arak
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Axefall")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 950 then -- Nagrand
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 978 then -- Ashran
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 945 then -- Tanaan Jungle
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933UnKnown")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
                    end  
                end
            end
        end
    end
end
            
  
            
            -- COUNT DOWN HERBS AND ORE --
function GarrisonDone_CountOre(self, event, ...)
        if event == "UNIT_SPELLCAST_START" then
        local unit, spell = ...
		if (unit == "player" and spell == "Mining") then
            return
        end
        elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
            local unit, spell = ...
		if (unit == "player" and spell == "Mining") then
            GarrisonDone_OreCounter(self, GarrisonDone_CountOre);
        end
    end
end

function GarrisonDone_OreCounter(self, GarrisonDone_CountOre)
        local zoneText = GetMinimapZoneText();
		local zoneName = GetSubZoneText();
		if (zoneName == "Lunarfall Excavation" or zoneName == "Frostwall Mine") or (zoneText == "Lunarfall Excavation" or zoneText == "Frostwall Mine") then
			GarrisonDone_Varsc.miningLeft = GarrisonDone_Varsc.miningLeft - 1;
            GarrisonDone_Update(self);
        DEFAULT_CHAT_FRAME:AddMessage("Were Mining") -- Debug --
    end
end
    
function GarrisonDone_CountHerbs(self, event, ...)
        if event == "UNIT_SPELLCAST_START" then
            local unit, spell = ...
		if ((spell == "Herbalism" or spell == "Herb Gathering") and unit == "player") then
            return
        end
        elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
            local unit, spell = ...
		if ((spell == "Herbalism" or spell == "Herb Gathering") and unit == "player") then
            GarrisonDone_HerbCount(self, GarrisonDone_CountHerbs);
        end
    end
end

function GarrisonDone_HerbCount(self, GarrisonDone_CountHerbs)
        local playerName = UnitName("player");
        local zoneText = GetMinimapZoneText();
		local zoneName = GetSubZoneText();
		if zoneText == (""..playerName.."'s Garrison") or zoneText == (""..playerName.."'s Fort") then  -- would still like this to be the garden --
			GarrisonDone_Varsc.herbingLeft = GarrisonDone_Varsc.herbingLeft - 1;
            GarrisonDone_Update(self);
        DEFAULT_CHAT_FRAME:AddMessage("Were Herbing") -- Debug --
    end
end




        -- Set Old times based on logout so reset works --
function GarrisonDone_OnLogout(self, event, ...)        
    if event == "PLAYER_LOGOUT" then
        GarrisonDone_Varsc.lastLogout = {
			["time"] = time(),
			["resetTime"] = GetQuestResetTime(),
		}
    end
end
    
     
   
        -- SHOW FRAME and Update --    
function GarrisonDone_OnShow(self)
    GarrisonDoneFrame:Show();
    PanelTemplates_SetTab(GarrisonDoneFrame, 1);
    if GarrisonDoneEditFrame:Show() == true then
        GarrisonDone_Update(self);
    end
        GarrisonDoneAltEditFrame:Hide();
        GarrisonDoneOptEditFrame:Hide();
end 


function GarrisonDone_OpenFrame(self, GarrisonMissionFrame)
    if HideUIPanel(GarrisonMissionFrame) then
        GarrisonDoneFrame:Show();
    end
end
 
 
        -- TOGGLES FRAME USEING SLASH COMMAND --
function GarrisonDone_Slash_Command(sMsg)
	if GarrisonDoneFrame:IsVisible() then
		GarrisonDoneFrame:Hide();
	else
		GarrisonDoneFrame:Show();
        GarrisonDoneEditFrame:Show();
        GarrisonDoneAltEditFrame:Hide();
        GarrisonDoneOptEditFrame:Hide();
	end
end
  
        -- MOVES FRAME --
function GarrisonDone_OnMouseDown(self)
    if (IsShiftKeyDown() and Button == "Shift-RightButton") then
	    GarrisonDoneFrame:StartMoving();
    end
end
  
function GarrisonDone_OnMouseUp(self)
	if (IsShiftKeyDown() and Button == "Shift-RightButton") then
	GarrisonDoneFrame:StopMovingOrSizing();
	end
end
 
 
        -- FLOATING BUTTON --
function GarrisonDone_ShowMini(self, event, ...)
    if event == "PLAYER_ENTERING_WORLD" then
	if (GarrisonDone_Varsc.button == true) then
        MGDButton:Show();
        end
    elseif (GarrisonDone_Varsc.button ~= true) then
        MGDButton:Hide();
    end
end


        -- MGD Button Tooltip --
function MGDButton_OnEnter(MGDButton)
    GameTooltip:SetOwner(MGDButton, "ANCHOR_BOTTOMLEFT")
    GameTooltip:SetText("My Garrison is Done")
    GameTooltip:AddLine("Left Click to Open My Garrison", 1, 1, 1)
    GameTooltip:AddLine("Shift Right Click to Move", 1, 1, 1)
    GameTooltip:AddLine("Shift Right Click to Save Position", 1, 1, 1)
    GameTooltip:Show();
end

function MGDButton_OnLeave(MGDButton)
    GameTooltip:Hide()
end

      

        -- REMOVES FRAME IF DISABLE TRUE --
function GarrisonDone_MakeESCable(frame,disable)
	local idx
	for i=1,#(UISpecialFrames) do
		if UISpecialFrames[i]==frame then
			idx = i
			break
		end
	end
	if idx and disable then
		table.remove(UISpecialFrames,idx)
	elseif not idx and not disable then
		table.insert(UISpecialFrames,1,frame)
	end
end
  
 
        -- ON TEXT CHANGE we will probably need to do something here --
function GarrisonDone_OnTextChanged(self)
    end

        -- Set timer for Ore and Herbs Reset --
function GarrisonDone_CompLogin(toon, when)
	local oldTime = GarrisonDone_Varsc.lastLogout.time
    local oldResetTime = GarrisonDone_Varsc.lastLogout.resetTime
        GarrisonDone_Varsc.lastLogin = {
			["time"] = time(),
			["resetTime"] = GetQuestResetTime(),
		}
        -- it's more than a day or quest reset timer has popped --
	if (GarrisonDone_Varsc.lastLogin.time - oldTime > 86400 or oldResetTime < GetQuestResetTime()) then
        GarrisonDone_Reset(toon, when);
	end
end
  
        -- find and Store Ore and Herbs --
function GarrisonDone_Reset(toon, when)
	local mines = {61, 62, 63}
	local gardens = {29, 136, 137}
    local ores = {8, 13, 18}
	local herbs = {6, 10, 15}
	local ore, herb
	local buildings, myMine, myGarden = C_Garrison.GetBuildings()
	for i = 1, #buildings do
		local buildingID = buildings[i].buildingID
		for k, v in ipairs(mines) do
			if v == buildingID then
				myMine = v
			end
		end
		for k, v in ipairs(gardens) do
			if v == buildingID then
				myGarden = v
			end
		end
	end
	if myMine == 61 then
		GarrisonDone_Varsc.miningLeft = 8;
		GarrisonDone_Varsc.maxMining = 8;
		GarrisonDone_Varsc.hasMine = true;
    elseif myMine == 62 then
		GarrisonDone_Varsc.miningLeft = 13;
		GarrisonDone_Varsc.maxMining = 13;
		GarrisonDone_Varsc.hasMine = true;
    elseif myMine == 63 then
		GarrisonDone_Varsc.miningLeft = 18;
		GarrisonDone_Varsc.maxMining = 18;
		GarrisonDone_Varsc.hasMine = true;
    end
	if myGarden == 29 then
		GarrisonDone_Varsc.herbingLeft = 6;
		GarrisonDone_Varsc.maxHerbing = 6;
		GarrisonDone_Varsc.hasGarden = true;
    elseif myGarden == 136 then
		GarrisonDone_Varsc.herbingLeft = 10;
		GarrisonDone_Varsc.maxHerbing = 10;
		GarrisonDone_Varsc.hasGarden = true;
    elseif myGarden == 137 then
		GarrisonDone_Varsc.herbingLeft = 15;
		GarrisonDone_Varsc.maxHerbing = 15;
		GarrisonDone_Varsc.hasGarden = true;
	end
end

 
 

-- TEXT FUNCTIONS --

function GarrisonDone_Update(self)
    -- Assign Local Variables straight from Blizz frame --
    
    
    -- Max Followers --
    local maxFollowers = C_Garrison.GetFollowerSoftCap();
    
    
    -- Active Followers --
    local numActiveFollowers = C_Garrison.GetNumActiveFollowers();
    
    
    -- Missions Available --
    local AvailableItems = C_Garrison.GetAvailableMissions();
    
    
    -- Missions Complete --
    local completeMissions = C_Garrison.GetCompleteMissions();
    
    -- Missions in Progress --
    local items = C_Garrison.GetLandingPageItems();  
    local mip = #items - #completeMissions;


    -- Mining Nodes --
    local ore = 0;
    if GarrisonDone_Varsc.hasMine == true then
		if GarrisonDone_Varsc.miningLeft > 0 then
		ore = format("%s", GarrisonDone_Varsc.miningLeft)
            tonumber(ore)
		end
    end
    local ores = 0;
    if GarrisonDone_Varsc.hasMine == true then
		if GarrisonDone_Varsc.maxMining > 0 then
		ores = format("%s", GarrisonDone_Varsc.maxMining)
            tonumber(ores)
		end
	end 
    
    
    -- Herb Nodes --
    local herb = 0;
    if GarrisonDone_Varsc.hasGarden == true then
    	if GarrisonDone_Varsc.herbingLeft > 0 then
		herb = format("%s", GarrisonDone_Varsc.herbingLeft)
            tonumber(herb)
		end
	end 
    local herbs = 0;
    if GarrisonDone_Varsc.hasGarden == true then
		if GarrisonDone_Varsc.maxHerbing > 0 then
		herbs = format("%s", GarrisonDone_Varsc.maxHerbing)
            tonumber(herbs)
		end
	end
    
    
        -- Find all our Followers and Set Status --
    local followers = C_Garrison.GetFollowers();
    
    -- Followers working --
    local work = 0;
    for i = 1, #followers do
	if ( followers[i].status == GARRISON_FOLLOWER_WORKING) then
		work = work + 1;
        end
    end
    -- Followers on Missions --
    local gfm = 0;
    for i = 1, #followers do
	if ( followers[i].status == GARRISON_FOLLOWER_ON_MISSION) then
		gfm = gfm + 1;
        end
    end
       
    local fBusy = gfm + work;
    local available = numActiveFollowers - fBusy;

        -- Garrison Resources --
    local _, currentAmount, _, _, _, _, _ = GetCurrencyInfo(824);

    
	-- Set Contents Main Frame --
	if (GarrisonDoneEditFrame:IsShown()) then
        -- Players Garrison --
		GarrisonDonePageName:SetText(""..playerName.."'s  Garrison");
        -- Max Followers --
		MGDTFPageName:SetText("|cffFF8000Total Followers|cff007fff = |r"..numActiveFollowers.."|cff007fff/|cffFF8000"..maxFollowers.."");
            if numActiveFollowers == 25 then
        MGDTFPageName:SetText("|cffFF8000Total Followers|cff007fff = |r|cff00aa00"..numActiveFollowers.."|cff007fff/|cffFF8000"..maxFollowers..""); 
            elseif numActiveFollowers > 25 then
        MGDTFPageName:SetText("|cffFF8000Total Followers|cff007fff = |r|cffff0000"..numActiveFollowers.."|cff007fff/|cffFF8000"..maxFollowers..""); 
            end
        -- Missions in Progress --
            if mip ~= 0 then
		MGDFMPageName:SetText("Missions in Progress|cff007fff = |cffffffff"..mip.."");
            elseif mip == 0 then
        MGDFMPageName:SetText("|cffffffffMissions in Progress|cff007fff = |r|cffff0000"..mip.."");
            end
        -- Complete Missions --
		MGDMCPageName:SetText("Missions Complete|cff007fff = |cff00aa00"..#completeMissions.."");
        -- Missions Available --
		MGDMAPageName:SetText("Missions Available|cff007fff = |r"..#AvailableItems.."");
        -- Followers Available --
		MGDFAPageName:SetText("Followers Available|cff007fff = |r"..available.."");
            if available == 0 then
        MGDFAPageName:SetText("Followers Available|cff007fff = |r|cff00aa00"..available.."");
            elseif available > 25 then
        MGDFAPageName:SetText("Followers Available|cff007fff = |r|cffff0000"..available.."");       
            end
        -- Followers Working
		MGDFWPageName:SetText("Followers Working|cff007fff = |r"..work.."");
        -- Followers on Mission
	    MGDFOMPageName:SetText("Followers on Mission|cff007fff = |cffFF8000"..gfm.."");
            if gfm == 0 then
        MGDFOMPageName:SetText("Followers on Mission|cff007fff = |cffff0000"..gfm.."");
            end
        -- Mining Nodes --
            if ore ~= 0 then
		MGDMNPageName:SetText("Mining Nodes|cff007fff = |cffff0000"..ore.."|cff007fff/|cff00aa00"..ores.."");
            elseif ore == 0 then
        MGDMNPageName:SetText("Mining Nodes|cff007fff = |r"..ore.."|cff007fff/|cff00aa00"..ores.."");
            end
        -- Herb Nodes --
            if herb ~= 0 then
		MGDHNPageName:SetText("Nice Flowers|cff007fff = |cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs.."");
            elseif herb == 0 then
        MGDHNPageName:SetText("Nice Flowers|cff007fff = |r"..herb.."|cff007fff/|cff00aa00"..herbs.."");  
            end
        -- Garrison Resources --
		MGDGRPageName:SetText("Garrison Resource|cff007fff = |r"..currentAmount.."")
    end
end
	
    
    
        -- Set Contents Alt Frame --
        -- add in pairs for multi toons later here --
function GarrisonDone_AltsMissions(self)   
        if (GarrisonDoneAltEditFrame:IsShown()) then
        -- Alts Garrisons --
		GarrisonDoneAltPageName:SetText("My Alts Garrison Missions");
        -- Alt Players Name --
		MGDACPageName:SetText(" Your alt's  Garrison");
        -- Missions Complete and in Progress --  
		MGDACMPageName:SetText("Complete|cff007fff = |cff00aa00 0|r - In Prog|cff007fff = |r0");
    end
end

          
        -- Auto Open Variable --
function GarrisonDone_Auto(self, MGD_Auto)
        local state = MGD_Auto:GetChecked()
	    if state then
		GarrisonDone_Varsc.auto = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Auto open is now ON");
        else
        GarrisonDone_Varsc.auto = false;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Auto Open is now OFF");
	end
end
        -- MGD Auto Open Tooltip --
function MGD_Auto_OnEnter(MGD_Auto)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Auto Opening")
    GameTooltip:AddLine("Toggles the Auto Open Function in Your Garrison.", 1, 1, 1)
    GameTooltip:AddLine("Will still Auto Open on Entering Town Hall", 1, 1, 1)
    GameTooltip:Show();
end


        -- Audio Warning Variable --
function GarrisonDone_Warn(self, MGD_Warn)
        local state = MGD_Warn:GetChecked()
	    if state then
		GarrisonDone_Varsc.warning = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Warning Sound is now ON");
        else
        GarrisonDone_Varsc.warning = false;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Warning Sound is now OFF");
	end
end      
        -- MGD Audio Warning Tooltip --
function MGD_Warn_OnEnter(MGD_Warn)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Audio Raid Warning")
    GameTooltip:AddLine("Toggles the Raid Warning Function.", 1, 1, 1)
    GameTooltip:AddLine("Will still operate on Flight Path Open", 1, 1, 1)
    GameTooltip:Show();
end


        -- Mini Button Variable --     
function GarrisonDone_MiniButton(self, MGD_Mini)
        local state = MGD_Mini:GetChecked()
	    if state then
		GarrisonDone_Varsc.button = true;
        MGDButton:Show()
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Button is now ON");
	    else
		GarrisonDone_Varsc.button = false;
        MGDButton:Hide()
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Button is now OFF"); 
	end
end
        -- MGD Floating Button Tooltip --
function MGD_Mini_OnEnter(MGD_Mini)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Floating Button")
    GameTooltip:AddLine("Toggles the Garriosn Done floating Button", 1, 1, 1)
    GameTooltip:Show();
end


        -- Manual Window Control --
function GarrisonDone_Manual(self, MGD_Manual)
        local state = MGD_Manual:GetChecked()
	    if state then
		GarrisonDone_Varsc.manual = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Manual Window Control is ON");
	    else
		GarrisonDone_Varsc.manual = false;
    
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Manual Window Control is OFF"); 
	end
end
        -- Manual Window Control Tooltip --
function MGD_Manual_OnEnter(MGD_Manual)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Manual Window Control")
    GameTooltip:AddLine("Turns Off Auto Close", 1, 1, 1)
    GameTooltip:Show();
end


        -- Hide Nodes Variable --
function GarrisonDone_Node(self, MGD_Node)
        local state = MGD_Node:GetChecked()
	    if state then
		GarrisonDone_Varsc.nodes = true;
    --    MGD_Node:Show();
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Show Mining/Herb Nodes");
	    else
		GarrisonDone_Varsc.nodes = false;
    --    MGD_Node:Hide();
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Hide Mining/Herb Nodes"); 
	end
end
        -- MGD Hide Nodes Tooltip --
function MGD_Node_OnEnter(MGD_Node)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Hide Nodes")
    GameTooltip:AddLine("Hides the Mining/Herb nodes", 1, 1, 1)
    GameTooltip:AddLine("on your minimap in the Garrison.", 1, 1, 1)
    GameTooltip:AddLine("Function not yet available.", 1, 1, 1)
    GameTooltip:Show();
end

        
        
        -- Set Options Frame --
function GarrisonDone_OptionsOnShow(self)   
        if (GarrisonDoneOptEditFrame:IsShown()) then
        -- Alts Garrisons --
		GarrisonDoneOptPageName:SetText("Options Panel");
        -- Alt Players Name --
		MGDOptPageName:SetText("My Garrison is Done");
        -- Missions Complete and in Progress --  
		MGDOptCPageName:SetText("|cffFF8000Verison - |cff00aa00"..GarrisonDone_Version.."");
        MGD_Auto:SetChecked(GarrisonDone_Varsc.auto)
        MGD_Warn:SetChecked(GarrisonDone_Varsc.warning)
        MGD_Mini:SetChecked(GarrisonDone_Varsc.button)
        MGD_Node:SetChecked(GarrisonDone_Varsc.manual)
        MGD_Node:SetChecked(GarrisonDone_Varsc.nodes)
    end
end
   
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        -- LDB LAUNCHER --
            -- might change this to ldb display -- or better add Ldb Display --
local mgdldb = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("GarrisonDone", {
            type = "launcher",
	        text = "My Garrison",
            label = "My Garrison",
            tocname = "GarrisonDone",
            icon = "Interface\\AddOns\\GarrisonDone\\images\\MGDL.tga",
            OnClick = function(self, button, ...)
            if (button == "LeftButton") then
		    if GarrisonDoneFrame:IsShown() then
                GarrisonDoneFrame:Hide()
                else
                GarrisonDoneFrame:Show()
                end
       	    elseif (button == "RightButton") then
		    InterfaceOptionsFrame_OpenToCategory("GarrisonDone")
            InterfaceOptionsFrame_OpenToCategory("GarrisonDone")
                end    
            end,
            OnTooltipShow = function(tooltip)
                tooltip:AddLine('My Garrison is Done ('..GarrisonDone_Version..')')
                tooltip:AddLine('|cffffff00Left click for My Garrison Panel')
                tooltip:AddLine('|cffffff00Right Click for Interface Panel')
            end,
        })
        

   -- INTERFACE OPTIONS MENU -- 
 
	local garrisondone = CreateFrame("Frame", "GarrisonDone", UIParent)
	garrisondone:Hide()
    garrisondone:IsResizable(true)
    garrisondone:SetMinResize(350,250)
	garrisondone.name = "My Garrison"
    garrisondone:SetBackdropColor(0, 0, 0, 1)
	garrisondone:SetWidth(250)
	garrisondone:SetHeight(400)
	garrisondone:SetPoint("CENTER", UIParent, "CENTER")
	InterfaceOptions_AddCategory(garrisondone)

	local title = garrisondone:CreateFontString("GarrisonDoneTitle", "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -20)
	title:SetText("My Garrison is Done ("..GarrisonDone_Version..")" )
 
    
    local mgdEditBox = CreateFrame("EditBox", "GarrisonDoneEditBox", garrisondone)
    mgdEditBox:SetPoint ("TOPLEFT",26,-42)
	mgdEditBox:EnableMouse(false)
	mgdEditBox:SetAutoFocus(false)
	mgdEditBox:SetFontObject(GameFontNormal)
	mgdEditBox:SetWidth(450)
	mgdEditBox:SetHeight(120)
    mgdEditBox:SetText("")
	mgdEditBox:Show()
    
    local mgdEditBoxText = mgdEditBox:CreateFontString("GarrisonDoneEditBoxTitle", "ARTWORK", "GameFontHighlight")
	mgdEditBoxText:SetPoint("BOTTOMLEFT", mgdEditBox, 5, -5)
	mgdEditBoxText:SetWidth(420)
	mgdEditBoxText:SetHeight(110)
    mgdEditBoxText:SetFontObject(GameFontHighlight)
    mgdEditBoxText:SetJustifyH("LEFT")
	mgdEditBoxText:SetText("Tracks how may Followers you have active, adjusts to LvL automatically (18/20 or 22/25). Monitors your missions so you Know how many are complete, How many are still in Progress, How many new Missions Waiting. Monitors your Followers Activities, How Many are assigned to Buildings, How many are in the Inn Drinking instead of being out on a Mission. Monitors your Herb and Mine nodes based on Building LvL and counts down as you Pick and Mine, (resets at Quest reset or over 24 Hours. Displays your Current Resources.")
    
    local mgdEditBoxText2 = mgdEditBox:CreateFontString("GarrisonDoneEditBoxTitle", "ARTWORK", "GameFontHighlight")
	mgdEditBoxText2:SetPoint("BOTTOMLEFT", mgdEditBox, 5, -115)
	mgdEditBoxText2:SetWidth(420)
	mgdEditBoxText2:SetHeight(110)
    mgdEditBoxText2:SetFontObject(GameFontHighlight)
    mgdEditBoxText2:SetJustifyH("LEFT")
	mgdEditBoxText2:SetText("Has it's own Floating button to put where you want it. Working Full LDB Launcher. |cff007fffJaxom of Hellfire EU")
      
    